unit myfuncs;

interface

uses
  SysUtils, ibase, ib_externals, fb_descriptors, math;

function FDOM(ib_date: PISC_QUAD): PISC_QUAD; cdecl; export;
function Limpa(sz, szRes: PChar): PChar; cdecl; export;
function StrBlob(sz: PChar; Blob: PBlob): PBlob; cdecl; export;
function Power(val1, val2, resultado: PParamDsc): PParamDsc; cdecl; export;

implementation

{ Retirado do Fonte do IBO }

function isc_decode_TDateTime(const Src: PISC_QUAD): TDateTime;
begin
  Result := Src^.gds_quad_high - 15018;
  try
    Result := Result + EncodeTime((Src^.gds_quad_low div (36000000)),
      (Src^.gds_quad_low div (600000)) mod 60,
      (Src^.gds_quad_low div (10000)) mod 60,
      (Src^.gds_quad_low mod (10000)) div 10);
  except
    Result := Result + 0;
  end;
end;

{ Retirado do Fonte do IBO }

procedure isc_encode_TDateTime(const Src: TDateTime; const Dst: PISC_QUAD);
var
  Hour, Min, Sec, MSec: word;
begin
  DecodeTime(Src, Hour, Min, Sec, MSec);
  with Dst^ do
  begin
    gds_quad_high := Trunc(Src) + 15018;
    gds_quad_low := Hour * 10000 * 60 * 60 +
      Min * 10000 * 60 +
      Sec * 10000 +
      MSec * 10;
  end;
end;

// Retorna o primeiro dia do ms

function FDOM(ib_date: PISC_QUAD): PISC_QUAD;
var
  Ano, Mes, Dia, Hora, Min, Seg, MilSeg: word;
  Data: TDateTime;
begin
  result := ib_date;
  Data := isc_decode_TDateTime(ib_date);
  DecodeDate(Data, Ano, Mes, Dia);
  DecodeTime(Data, Hora, Min, Seg, MilSeg);
  Dia := 1;
  Data := EncodeDate(Ano, Mes, Dia);
  ReplaceTime(data, EncodeTime(Hora, Min, Seg, MilSeg));
  isc_encode_TDateTime(Data, result);
end;

// Funo para remover caracteres que no sejam letras e nmeros

function Limpa(sz, szRes: PChar): PChar;
begin
  result := szRes;
  while (sz^ <> #0) do
  begin
    if sz^ in ['A'..'Z', 'a'..'z', '0'..'9'] then
    begin
      szRes^ := sz^;
      inc(szRes);
    end;
    Inc(sz);
  end;
  szRes^ := #0;
end;

//Recebe um string e retorna o string na forma de blob

function StrBlob(sz: PChar; Blob: PBlob): PBlob;
begin
  result := Blob;
  if (not Assigned(Blob)) or
    (not Assigned(Blob^.BlobHandle)) then exit;
  Blob^.PutSegment(Blob^.BlobHandle, sz, StrLen(sz));
end;

//Recebe dois valores e devolve o resultado de valor1 elevado a valor2

function Power(val1, val2, resultado: PParamDsc): PParamDsc;
var
  v1, v2: Double;
  rc, rc2: Smallint;
begin
  Result := resultado;
  if ((val1 = nil) or ((val1^.dsc_flags and DSC_null) <> 0)) or
    ((val2 = nil) or ((val2^.dsc_flags and DSC_null) <> 0)) then
  begin
    Resultado.dsc_flags := DSC_NULL;
    Exit;
  end;
  rc := get_scaled_double(val1, v1);
  rc2 := get_scaled_double(val2, v2);
  if (rc < 0) or (rc2 < 0) or (not rc and rc < 0) then
  begin
    Resultado.dsc_flags := DSC_NULL;
    Exit;
  end;
  Set_Double_Type(resultado,Math.Power(v1, v2));
  resultado.dsc_scale := 0;
end;

initialization

  isMultiThread := true;

end.

